<?php
require_once "../../maincore.php";
require_once BASEDIR."subheader.php";
require_once BASEDIR."side_left.php";

if (file_exists(INFUSIONS."mod_tracker/lang/".LOCALESET.".php")) {
	include INFUSIONS."mod_tracker/lang/".LOCALESET.".php";
} else {
	include INFUSIONS."mod_tracker/lang/russian.php";
}

require_once INFUSIONS."mod_tracker/include_benc.php";
require_once INFUSIONS."mod_tracker/include_bittorrent.php";

if(!isset($act)) $act = "";

opentable($lang['tracker_000']);
	echo "<table cellpadding='0' cellspacing='1' width='100%' class='tbl-border'>\n";
	echo "<tr><td class='tbl1'>\n";
	echo "<a href='".FUSION_SELF."?act=browse'>".$lang['tracker_011']."</a>\n";
	if (iMEMBER) {
		echo "<a href='".FUSION_SELF."?act=upload'>".$lang['tracker_upload_000']."</a>\n";
		$result = dbquery("SELECT * FROM ".DB_PREFIX."mod_tracker_users WHERE user_id='".$userdata['user_id']."'");
		if (dbrows($result) != 0) { $client_data = dbarray($result); } else { $client_data['downloaded'] = 0; }
		echo " ".(($client_data['downloaded'] > 0) ? (round($client_data['uploaded'] / $client_data['downloaded'], 3)) : "0.000");
	}
	echo "</td></tr>\n";
	$result = dbquery("SELECT * FROM ".DB_PREFIX."mod_tracker_categories ORDER BY cat_id DESC");
	if (dbrows($result) != 0) {
		echo "<tr><td class='tbl1' align='center'>\n";
		echo "<table cellpadding='0' cellspacing='1' width='100%'>\n";
		while ($data = dbarray($result)) {
			echo "<td><a href='".FUSION_SELF."?act=browse&amp;cat=".$data['cat_id']."'><img style='border:0;' alt='".$data['cat_name']."' src='".INFUSIONS."mod_tracker/images/cats/".$data['cat_image']."'></a></td>\n";
		}
		echo "</table>\n</td></tr>\n";
	}
	echo "</table>\n";
closetable();

function parse_err($msg) {
	global $lang, $locale, $settings, $db_prefix, $theme_width_r;
	opentable($lang['tracker_err_000']);
	echo "<center>$msg</center>";
	closetable();
	include BASEDIR."side_right.php";
	include BASEDIR."footer.php";
	exit;
}

if (isset($_POST['add_torrent'])) {
	foreach(explode(":","description:cat_id:name") as $v) {
		if (!isset($_POST[$v]))	parse_err($lang['tracker_err_001']);
	}

	if (!isset($_FILES['file'])) parse_err($lang['tracker_err_001']);
	$f = $_FILES['file'];
	$fname = unesc($f['name']);

	if (empty($fname)) parse_err($lang['tracker_err_002']);
	if (!preg_match('/^[^\0-\x1f:\\\\\/?*\xff#<>|]+$/si', $fname)) parse_err($lang['tracker_err_002']);
	if (!preg_match('/^(.+)\.torrent$/si', $fname, $matches)) parse_err($lang['tracker_err_002']." (not a .torrent).");
	$shortfname = $torrent = $matches[1];

	if (!empty($_POST['name'])) $torrent = trim(stripinput($_POST['name']));
	$tmpname = $f['tmp_name'];
	if (!is_uploaded_file($tmpname)) parse_err("eek");
	if (!filesize($tmpname)) parse_err($lang['tracker_err_003']);
	$dict = bdec_file($tmpname, 1000000);
	if (!isset($dict)) parse_err($lang['tracker_err_004']);

	list($ann, $info) = dict_check($dict, "announce(string):info");
	list($dname, $plen, $pieces) = dict_check($info, "name(string):piece length(integer):pieces(string)");

	if ($ann != $settings['siteurl']."infusions/mod_tracker/announce.php") parse_err($lang['tracker_err_005']);

	if (strlen($pieces) % 20 != 0) parse_err($lang['tracker_err_006']);

	$filelist = array();
	$totallen = dict_get($info, "length", "integer");
	if (isset($totallen)) {
		$filelist[] = array($dname, $totallen);
		$type = "single";
	} else {
		$flist = dict_get($info, "files", "list");
		if (!isset($flist)) parse_err($lang['tracker_err_007']);
		if (!count($flist)) parse_err($lang['tracker_err_008']);
		$totallen = 0;
		foreach ($flist as $fn) {
			list($ll, $ff) = dict_check($fn, "length(integer):path(list)");
			$totallen += $ll;
			$ffa = array();
			foreach ($ff as $ffe) {
				if ($ffe["type"] != "string") parse_err($lang['tracker_err_009']);
				$ffa[] = $ffe["value"];
			}
			if (!count($ffa)) parse_err($lang['tracker_err_009']);
			$ffe = implode("/", $ffa);
			$filelist[] = array($ffe, $ll);
		}
		$type = "multi";
	}
	$infohash = pack("H*", sha1($info['string']));
	$rows = dbrows(dbquery("SELECT * FROM ".DB_PREFIX."mod_tracker_torrents WHERE ".hash_where("info_hash", $infohash)));
	if ($rows == 0) {
		$result = dbquery("INSERT INTO ".DB_PREFIX."mod_tracker_torrents VALUES ('', '".preg_replace_callback("/./s", "hex_esc", hash_pad($infohash))."', '$torrent', '$fname', '$dname', '".trim(stripinput($_POST['description']))."', '".$_POST['cat_id']."', '$totallen', NOW(), '$type', '".count($filelist)."', '0', NOW(), 'no', '".$userdata['user_id']."', '0', '0', 'no')");
	} else {
		parse_err($lang['tracker_err_010']);
	}
	$id = 0 + mysql_insert_id();
	$result = dbquery("DELETE FROM ".DB_PREFIX."mod_tracker_files WHERE torrent='$id'");
	foreach ($filelist as $file) {
		$result = dbquery("INSERT INTO ".DB_PREFIX."mod_tracker_files VALUES ('', $id, '".$file[0]."', '".$file[1]."')");
	}
	move_uploaded_file($tmpname, INFUSIONS."mod_tracker/torrents/".$id.".torrent");
	redirect(FUSION_SELF."?act=view&view=$id");
}

if ($act == "upload") {
	if (!iMEMBER) redirect(FUSION_SELF);
	opentable($lang['tracker_upload_000']);
	echo "<form name='inputform' method='post' enctype='multipart/form-data' action='".FUSION_SELF."'>
	<table width='100%' border='0' cellspacing='1' cellpadding='0' class='tbl-border'>
	<tr>
	<td width='145' class='tbl2'>".$lang['tracker_upload_001']."</td>
	<td class='tbl2'><input type='text' name='name' class='textbox' maxlength='255' style='width:400px'>
	<select name='cat_id' class='textbox'  style='width:120px'>\n";
	$result = dbquery("SELECT * FROM ".DB_PREFIX."mod_tracker_categories ORDER BY cat_name");
	// $cat_opts = ""; $sel = "";
	if (dbrows($result)) {
		while ($data = dbarray($result)) {
			//if (isset($news_cat)) $sel = ($news_cat == $data['news_cat_id'] ? " selected" : "");
			echo "<option value='".$data['cat_id']."'>".$data['cat_name']."</option>\n";
		}
	}
	echo "</select>
	</td>
	</tr>
	<tr>
	<td width='145' class='tbl2'>".$lang['tracker_upload_003']."</td>
	<td class='tbl2'>
	<input type='file' name='file' class='textbox' style='width:520px;'>
	</td>
	</tr>
	<tr>
	<td valign='top' width='145' class='tbl2'>".$lang['tracker_upload_004']."</td>
	<td class='tbl1'><textarea name='description' cols='100' rows='30' class='textbox'></textarea></td>
	</tr>
	<tr>
	<td width='145' class='tbl2'>&nbsp;</td>
	<td class='tbl2'>
	<input type='button' value='b' class='button' style='font-weight:bold;width:25px;' onClick=\"addText('description', '[b]', '[/b]');\">
	<input type='button' value='i' class='button' style='font-style:italic;width:25px;' onClick=\"addText('description', '[i]', '[/i]');\">
	<input type='button' value='u' class='button' style='text-decoration:underline;width:25px;' onClick=\"addText('description', '[u]', '[/u]');\">
	<input type='button' value='url' class='button' style='width:30px;' onClick=\"addText('description', '[url]', '[/url]');\">
	<input type='button' value='mail' class='button' style='width:35px;' onClick=\"addText('description', '[mail]', '[/mail]');\">
	<input type='button' value='img' class='button' style='width:30px;' onClick=\"addText('description', '[img]', '[/img]');\">
	<input type='button' value='center' class='button' style='width:45px;' onClick=\"addText('description', '[center]', '[/center]');\">
	<input type='button' value='small' class='button' style='width:40px;' onClick=\"addText('description', '[small]', '[/small]');\">
	<input type='button' value='code' class='button' style='width:40px;' onClick=\"addText('description', '[code]', '[/code]');\">
	<input type='button' value='quote' class='button' style='width:45px;' onClick=\"addText('description', '[quote]', '[/quote]');\">
	<select name='bbcolor' class='textbox' style='width:90px;' onChange=\"addText('description', '[color=' + this.options[this.selectedIndex].value + ']', '[/color]');this.selectedIndex=0;\">
	<option value=''>Default</option>
	<option value='maroon' style='color:maroon;'>Maroon</option>
	<option value='red' style='color:red;'>Red</option>
	<option value='orange' style='color:orange;'>Orange</option>
	<option value='brown' style='color:brown;'>Brown</option>
	<option value='yellow' style='color:yellow;'>Yellow</option>
	<option value='green' style='color:green;'>Green</option>
	<option value='lime' style='color:lime;'>Lime</option>
	<option value='olive' style='color:olive;'>Olive</option>
	<option value='cyan' style='color:cyan;'>Cyan</option>
	<option value='blue' style='color:blue;'>Blue</option>
	<option value='navy' style='color:navy;'>Navy Blue</option>
	<option value='purple' style='color:purple;'>Purple</option>
	<option value='violet' style='color:violet;'>Violet</option>
	<option value='black' style='color:black;'>Black</option>
	<option value='gray' style='color:gray;'>Gray</option>
	<option value='silver' style='color:silver;'>Silver</option>
	<option value='white' style='color:white;'>White</option>
	</select><br>
	".displaysmileys("description")."
	</td>
	</tr>
	<tr><td class='tbl1' colspan='2' align='center'><input type='submit' name='add_torrent' value='".$lang['tracker_upload_005']."' class='button'></td></tr>
	</table>
	</form>\n";
	closetable();
} else if ($act == "view") {
	if (isset($view) && !isNum($view)) redirect(FUSION_SELF);
	$result = dbquery("SELECT td.*, ud.*, tc.* FROM ".DB_PREFIX."mod_tracker_torrents td
	LEFT JOIN ".DB_PREFIX."users ud ON td.user_id=ud.user_id
	LEFT JOIN ".DB_PREFIX."mod_tracker_categories tc ON td.category=tc.cat_id
	WHERE id='$view' AND banned='no'");
	if (dbrows($result) == 0) redirect(FUSION_SELF);
	$data = dbarray($result);
	include INCLUDES."comments_include.php";
	include INCLUDES."ratings_include.php";
	opentable($lang['tracker_torrent_000']);
	if ($data['visible'] == 'no') echo "<center>".$lang['tracker_torrent_011']."</center>\n";
	echo "<table width='100%' border='0' cellspacing='1' cellpadding='0' class='tbl-border'>\n";
	echo "<tr>\n";
	echo "<td class='tbl2' width='170'>".$lang['tracker_002']."</td>\n";
	echo "<td class='tbl1'>".$data['name']."</td>\n";
	echo "</tr>\n";
	echo "<tr>\n";
	echo "<td class='tbl2'>".$lang['tracker_torrent_001']."</td>\n";
	echo "<td class='tbl1'><a href='".FUSION_SELF."?act=download&amp;id=".$data['id']."'>".$data['filename']."</a></td>\n";
	echo "</tr>\n";
	echo "<tr>\n";
	echo "<td class='tbl2'>".$lang['tracker_torrent_003']."</td>\n";
	echo "<td class='tbl1'>".$data['info_hash']."</a></td>\n";
	echo "</tr>\n";
	echo "<tr>\n";
	echo "<td class='tbl2'>".$lang['tracker_torrent_002']."</td>\n";
	echo "<td class='tbl1'>".nl2br(parseubb(parsesmileys($data['description'])))."</td>\n";
	echo "</tr>\n";
	echo "<tr>\n";
	echo "<td class='tbl2'>".$lang['tracker_torrent_004']."</td>\n";
	echo "<td class='tbl1'> <a href='".BASEDIR."profile.php?lookup=".$data['user_id']."'>".$data['user_name']."</a></td>\n";
	echo "</tr>\n";
	echo "<tr>\n";
	echo "<td class='tbl2'>".$lang['tracker_003']."</td>\n";
	echo "<td class='tbl1'>".parsebytesize($data['size'])."</td>\n";
	echo "</tr>\n";
	echo "<tr>\n";
	echo "<td class='tbl2'>".$lang['tracker_010']."</td>\n";
	echo "<td class='tbl1'><img src='".INFUSIONS."mod_tracker/images/health/health_".health($data['seeders'], $data['leechers']).".gif'>
	".$data['seeders']." ".$lang['tracker_torrent_008'].", ".$data['leechers']." ".$lang['tracker_torrent_009']." = ".dbcount("(*)", "mod_tracker_peers", "torrent='".$data['id']."'")." ".$lang['tracker_torrent_010']."
	</td>\n";
	echo "</tr>\n";
	echo "<tr>\n";
	echo "<td class='tbl2'>".$lang['tracker_001']."</td>\n";
	echo "<td class='tbl1'><img alt='".$data['cat_name']."' src='".INFUSIONS."mod_tracker/images/cats/".$data['cat_image']."'></td>\n";
	echo "</tr>\n";
	echo "<tr>\n";
	echo "<td class='tbl2'>".$lang['tracker_torrent_006']."</td>\n";
	echo "<td class='tbl1'>".$data['added']."</td>\n";
	echo "</tr>\n";
	echo "<tr>\n";
	echo "<td class='tbl2'>".$lang['tracker_torrent_005']."</td>\n";
	echo "<td class='tbl1'>".$data['last_action']."</td>\n";
	echo "</tr>\n";
	echo "</table>\n";
	closetable();
	opensidex($lang['tracker_torrent_007'], "off");
	echo "=)";
	closesidex();
	showcomments("T","mod_tracker_torrents","id",$data['id'],FUSION_SELF."?act=view&view=".$data['id']);
	showratings("T",$data['id'],FUSION_SELF."?act=view&view=".$data['id']);
} else if ($act == "download") {
	if (isset($id) && !isNum($id)) redirect(FUSION_SELF);
	$result = dbquery("SELECT * FROM ".DB_PREFIX."mod_tracker_torrents WHERE id='$id' AND banned='no'");
	if (dbrows($result) == 0) redirect(FUSION_SELF);
	if (!file_exists(INFUSIONS."mod_tracker/torrents/".$id.".torrent")) redirect(FUSION_SELF);
	$data = dbarray($result);
	$filesize = filesize(INFUSIONS."mod_tracker/torrents/".$id.".torrent");
	ob_end_clean();
	header("Content-Type: application/torrent");
	header('Content-Disposition: inline; filename="'.$data['filename'].'"');
	header("Content-Length: $filesize");
	echo file_get_contents(INFUSIONS."mod_tracker/torrents/".$id.".torrent");
	exit;
} else if ($act == "browse") {
	$where = "";
	if (isset($cat) && isNum($cat)) $where = " AND category='$cat'";
	opentable($lang['tracker_011']);
	echo "<table cellpadding='0' cellspacing='1' width='100%' class='tbl-border'>\n";
	$result = dbquery("SELECT * FROM ".DB_PREFIX."mod_tracker_torrents WHERE banned='no' AND visible='yes'".$where." ORDER BY id DESC LIMIT 30");
	if (dbrows($result) != 0) {
		$i = 0; $date = "";
		//<td class='tbl2'>".$lang['tracker_001']."</td>
		echo "<tr>
		<td class='tbl2' colspan='2'>".$lang['tracker_002']."</td>
		<td class='tbl2' align='center'>".$lang['tracker_003']."</td>
		<td class='tbl2' align='center'>".$lang['tracker_004']."</td>
		<td class='tbl2' align='center'>".$lang['tracker_005']."</td>
		<td class='tbl2' align='center'>".$lang['tracker_006']."</td>
		<td class='tbl2' align='center'>".$lang['tracker_007']."</td>
		<td class='tbl2' align='center'>".$lang['tracker_008']."</td>
		<td class='tbl2' align='center'>".$lang['tracker_009']."</td>
		<td class='tbl2' align='center' width='1%'>".$lang['tracker_010']."</td></tr>\n";
		while ($data = dbarray($result)) {
			$tbl_class = ($i % 2 == 0 ? "tbl1" : "tbl2"); $i++;
			$added = explode(" ", $data['added']);
			if ($date != $added[0]) {
				$date = $added[0];
				echo "<tr><td colspan='10' class='forum-caption'>$date</td></tr>\n";
			}
			$cdata = dbarray(dbquery("SELECT * FROM ".DB_PREFIX."mod_tracker_categories WHERE cat_id='".$data['category']."'"));
			echo "<tr>
			<td class='$tbl_class' width='1%'><img alt='".$cdata['cat_name']."' src='".INFUSIONS."mod_tracker/images/cats/".$cdata['cat_image']."'></td>
			<td class='$tbl_class'><a href='".FUSION_SELF."?act=view&amp;view=".$data['id']."'>".$data['name']."</a></td>
			<td class='$tbl_class' align='center'>".parsebytesize($data['size'])."</td>
			<td class='$tbl_class' align='center'>".$data['numfiles']."</td>
			<td class='$tbl_class' align='center'>".$data['times_completed']."</td>
			<td class='$tbl_class' align='center'>".dbcount("(comment_id)", "comments", "comment_type='T' AND comment_item_id='".$data['id']."'")."</td>
			<td class='$tbl_class' align='center'>".$data['files']."</td>
			<td class='$tbl_class' align='center'>".$data['seeders']."</td>
			<td class='$tbl_class' align='center'>".$data['leechers']."</td>
			<td class='$tbl_class' align='center'><img src='".INFUSIONS."mod_tracker/images/health/health_".health($data['seeders'], $data['leechers']).".gif'></td>
			</tr>";
		}
	} else {
		echo "<tr><td class='tbl2' align='center'></td></tr>";
	}
	echo "</table>\n";
	closetable();
} else {
	$result = dbquery("SELECT * FROM ".DB_PREFIX."mod_tracker_torrents WHERE banned='no' AND visible='yes'ORDER BY id DESC LIMIT 5");
	if (dbrows($result) != 0) {
		while ($data = dbarray($result)) {
			$cdata = dbarray(dbquery("SELECT * FROM ".DB_PREFIX."mod_tracker_categories WHERE cat_id='".$data['category']."'"));
			$udata = dbarray(dbquery("SELECT * FROM ".DB_PREFIX."users WHERE user_id='".$data['user_id']."'"));
			torrent_render($data, $cdata, $udata);
		}
	}
}
require_once BASEDIR."side_right.php";
require_once BASEDIR."footer.php";
?>
